// MemoryView.h
// Copyright(C) 1999 by Kiyoshi Kobayashi. All rights reserved.
//
//
#ifndef _MEMORY_VIEW_H_
#define _MEMORY_VIEW_H_

#include <View.h>
#include <Rect.h>
#include <List.h>

#include "BaseView.h"
#include "LabelStringView.h"
#include "LineGraphView.h"
#include "SysInfoObserver.h"

// Memory usage view
//
class _EXPORT MemoryView : public BaseView {
  public:
	MemoryView(BRect frame);
	MemoryView(BMessage *archive);
	~MemoryView();

	// BView
	void AttachedToWindow();
	void FrameResized(float width, float height);
	
	// Archivable
	status_t Archive(BMessage *archive, bool deep) const;
	static BArchivable *Instantiate(BMessage *archive);

	void Update(float rate);
	
  private:
	MemoryView(const MemoryView &);
	MemoryView &operator=(const MemoryView &) { return *this; };

	void Adjust(float width, float height);
	
	BList list;
	LabelStringView *sView;
	LineGraphView *gView;
	
	SysInfoObserver *obs;
};

#endif /* _MEMORY_VIEW_H_ */
